import tkinter as tk
from tkinter import messagebox
import random

root = tk.Tk()
text_list = tk.Text(root, font=12, width=70, height=12)
text_list.configure(state="disabled")
text_list.place(relx=0.34, rely=0.05)
text_tree = tk.Text(root, font=12, width=70, height=12)
text_tree.configure(state="disabled")
text_tree.place(relx=0.34, rely=0.55)
tree = None
temp = []


class Node_tree:
    def __init__(self, key, left=None, right=None):
        self.key = key
        self.left = left
        self.right = right

    def __str__(self):
        return "(%s %s %s)" % (self.left or "", self.key, self.right or "")


def insert(tree, key):
    if not tree:
        tree = Node_tree(key)
    elif key < tree.key:
        tree = Node_tree(tree.key, insert(tree.left, key), tree.right)
    elif key > tree.key:
        tree = Node_tree(tree.key, tree.left, insert(tree.right, key))
    return tree


def copy(tree):
    if tree:
        temp.append(tree.key)
        copy(tree.left)
        copy(tree.right)


class Node:
    def __init__(self, data):
        self.data = data
        self.next = None


class LinkedList:
    def __init__(self):
        self.head = None

    def append(self, data):
        if not self.head:
            self.head = Node(data)
            self.head.next = self.head
        else:
            newNode = Node(data)
            cur = self.head
            while cur.next != self.head:
                cur = cur.next
            cur.next = newNode
            newNode.next = self.head

    def check(self):
        if self.head is None:
            messagebox.showerror("Count error", "Список пуст")
            return
        cur = self.head
        curr = self.head
        count = 0
        while curr.next != cur:
            if curr.data == curr.next.next.data:
                count += 1
                curr = curr.next
            else:
                curr = curr.next
        else:
            if curr.data == curr.next.next.data:
                count += 1
        messagebox.showinfo("Соседи", "Элементов с одинаковыми соседями: " + str(count))


list_ = LinkedList()


def addList():
    text_list.configure(state="normal")
    if len(entry_list.get()) != 0:
        list_.append(entry_list.get())
        text_list.insert(0.0, entry_list.get() + '\n')
    else:
        messagebox.showerror("Entry error", "Поле ввода не должно быть пустым")
    text_list.configure(state="disabled")


times = random.randint(6, 15)
while times:
    element = random.randint(0, 50)
    tree = insert(tree, element)
    times += -1


def copyTree():
    tree2 = None
    copy(tree)
    for i in range(len(temp)):
        tree2 = insert(tree2, temp[i])
    text_tree.configure(state="normal")
    text_tree.insert(tk.END, '\nКопия дерева: ')
    text_tree.insert(tk.END, tree2)
    text_tree.configure(state="disabled")


def printTree(tree):
    text_tree.configure(state="normal")
    text_tree.insert(tk.END, '\nНачальное дерево: ')
    text_tree.insert(tk.END, tree)
    text_tree.configure(state="disabled")


# region UI создание графического интерфейса
label_list = tk.Label(root, font=12, text="Список:", fg='black', bg=None)
label_list.place(relx=0.4, rely=0.01, relwidth=0.50, relheight=0.03)

label_tree = tk.Label(root, font=12, text="Дерево:", fg='black', bg=None)
label_tree.place(relx=0.4, rely=0.5, relwidth=0.50, relheight=0.04)

button_add = tk.Button(root, text="Добавить элемент", bg='#2E8B57', command=lambda: addList())
button_add.place(relx=0.07, rely=0.11, relwidth=0.20, relheight=0.05)

button_check = tk.Button(root, text="Узнать результат", bg='#2E8B57', command=lambda: list_.check())
button_check.place(relx=0.07, rely=0.17, relwidth=0.20, relheight=0.05)

button_check_tree = tk.Button(root, text="Вывести дерево", bg='#2E8B57', command=lambda: printTree(tree))
button_check_tree.place(relx=0.07, rely=0.55, relwidth=0.20, relheight=0.05)

button_check_tre = tk.Button(root, text="Вывести копию", bg='#2E8B57', command=lambda: copyTree())
button_check_tre.place(relx=0.07, rely=0.61, relwidth=0.20, relheight=0.05)

entry_list = tk.Entry(root, font=12)
entry_list.place(relx=0.07, rely=0.05, relwidth=0.20, relheight=0.05)

label_list = tk.Label(root, font=12, text="Список:", fg='black')
label_list.place(relx=0, rely=0.05)

label_tree = tk.Label(root, font=12, text="Дерево:", fg='black')
label_tree.place(relx=0, rely=0.55)
# endregion

if __name__ == "__main__":
    root.title("Кольцевой список и дерево")
    root.geometry("1000x500")
    root.resizable(False, False)
    root.mainloop()
